load('NS_SunspotData');
Y = log(dat+1);
Y = Y-mean(Y,2)*ones(1,size(Y,2));
fs = 12;
J = size(Y,1);
T = size(Y,2);
MAX_OSC = 6;
MAX_VAR = 6;
tic
[decomp_phase,decomp_mu,decomp_cov,AIC_osc,osc_param] = oscV_decomp(Y,fs,MAX_OSC,MAX_VAR);
toc
[tmp,K] = min(AIC_osc);
plot_oscV_decomp(Y,fs,decomp_mu,decomp_cov,K);
plot_osc_phase(fs,decomp_phase,decomp_mu,decomp_cov,K);
osc_a = osc_param(K,1:K);
osc_f = osc_param(K,K+1:2*K);
osc_sigma = osc_param(K,2*K+1:3*K);
osc_c = osc_param(K,3*K+1:(2*J+1)*K);
osc_r = osc_param(K,(2*J+1)*K+1);
str = sprintf('The number of oscillators is K=%d.',K);
disp(str);
str = 'The periods of K oscillators are ';
for k=1:K-1
    str = [str sprintf('%.2f, ',1./osc_f(k))];
end
str = [str sprintf('%.2f years.',1./osc_f(K))];
disp(str);
str = 'The phase differences for K oscillators correspond to ';
for k=1:K-1
    str = [str sprintf('%.2f, ',atan2(osc_c(2*k),osc_c(2*k-1))/2/pi/osc_f(k))];
end
str = [str sprintf('%.2f years.',atan2(osc_c(2*K),osc_c(2*K-1))/2/pi/osc_f(K))];
disp(str);
