options = optimoptions('fminunc','Algorithm','quasi-newton','MaxFunEvals',10000);
tic

phi_prop = zeros(MAX_COMPONENT,T,MAX_COMPONENT);
decomp_mu = zeros(2*MAX_COMPONENT,T,MAX_COMPONENT);
decomp_cov = zeros(2*MAX_COMPONENT,2*MAX_COMPONENT,T,MAX_COMPONENT);
ABIC_prop = zeros(1,MAX_COMPONENT);
prop_a = zeros(MAX_COMPONENT,MAX_COMPONENT);
prop_f = zeros(MAX_COMPONENT,MAX_COMPONENT);
prop_sigma = zeros(MAX_COMPONENT,MAX_COMPONENT);
prop_w = zeros(MAX_COMPONENT,2*(d-1)*MAX_COMPONENT);
prop_r = zeros(MAX_COMPONENT,1);
for num_component=1:MAX_COMPONENT
    num_component,toc
    minABIC = inf;
    minABIC2 = inf;
    minK = inf;
    for ARdeg=ceil(num_component/d):MAX_AR %floor(2*num_component/d)
        [Vtmp,tmp] = polyeig_VAR(VARwithnoise_A(:,1:d*ARdeg,ARdeg));
        if d*ARdeg-nnz(imag(tmp))/2 == num_component && AIC_VARwithnoise(ARdeg) < minABIC
            V0 = Vtmp;
            z0 = tmp;
            E0 = VARwithnoise_E(:,:,ARdeg);
            R0 = VARwithnoise_r(ARdeg);
            minABIC = AIC_VARwithnoise(ARdeg);
            optARdeg = ARdeg;
        end
        if d*ARdeg-nnz(imag(tmp))/2 > num_component && (d*ARdeg-nnz(imag(tmp))/2 < minK || (d*ARdeg-nnz(imag(tmp))/2 == minK && AIC_VARwithnoise(ARdeg) < minABIC2))
            V1 = Vtmp;
            z1 = tmp;
            E1 = VARwithnoise_E(:,:,ARdeg);
            R1 = VARwithnoise_r(ARdeg);
            minABIC2 = AIC_VARwithnoise(ARdeg);
            optARdeg2 = ARdeg;
            minK = d*ARdeg-nnz(imag(tmp))/2;
        end
    end
    if minABIC == inf
        if minABIC2 == inf
            warning('no AR model with %d oscillators',num_component);
        end
        V0 = V1;
        z0 = z1;
        E0 = E1;
        R0 = R1;
        optARdeg = optARdeg2;
    end
    [tmp,ARdeg] = min(AIC_VARwithnoise);
    if ARdeg < MAX_AR
%        ARdeg = ARdeg+1;    % possibly effective
    end
    [Vtmp,tmp] = polyeig_VAR(VARwithnoise_A(:,1:d*ARdeg,ARdeg));
    if nnz(imag(tmp)>=0) >= num_component
        V0 = Vtmp;
        z0 = tmp;
        E0 = VARwithnoise_E(:,:,ARdeg);
        R0 = VARwithnoise_r(ARdeg);
        minABIC = AIC_VARwithnoise(ARdeg);
        optARdeg = ARdeg;
    end
    VV = zeros(d*optARdeg,d*optARdeg);
    for j=1:d*optARdeg
        for i=1:optARdeg
            VV((i-1)*d+1:i*d,j) = z0(j)^(1-i)*V0(:,j);
        end
    end
    QQ = inv(VV)*[E0 zeros(d,d*(optARdeg-1)); zeros(d*(optARdeg-1),d*optARdeg)]*inv(VV)';
    [B,I] = sort(diag(real(QQ))./(1-abs(z0).^2),'descend');
    V0 = V0(:,I);
    z0 = z0(I);
    if R0 == 0
        R0 = 10^-5;
    end
    init_a = zeros(1,num_component);
    init_f = zeros(1,num_component);
    init_w = zeros(1,2*(d-1)*num_component);
    kk = 1;
    for k=1:num_component
        init_a(k) = abs(z0(kk));
        init_f(k) = abs(angle(z0(kk)));
        if isreal(z0(kk)) && z0(kk) < 0
            init_f(k) = 4; % for pi
        end
        for ii=1:d-1
            init_w(2*(d-1)*(k-1)+2*ii-1) = real(V0(ii+1,kk)/V0(1,kk));
            if imag(z0(kk)) < 0
                init_w(2*(d-1)*(k-1)+2*ii) = imag(V0(ii+1,kk)/V0(1,kk));
            else
                init_w(2*(d-1)*(k-1)+2*ii) = -imag(V0(ii+1,kk)/V0(1,kk));
            end
        end
        if imag(z0(kk)) == 0
            kk = kk+1;
        else
            kk = kk+2;
        end
    end
    nf0 = nnz(init_f==0);
    nf1 = nnz(init_f==4);
    freq = init_f;
    freq(2:nf0) = pi*rand(1,nf0-1);
    freq(num_component-nf1+2:num_component) = pi*rand(1,nf1-1);
    if mod(T,2) == 0
        freq = [2*pi/T*(0:T/2-1) 4];
    else
        freq = [2*pi/T*(0:(T-1)/2)];
    end
    P = zeros(d*length(freq),num_component);
    for k=1:nf0
        a = init_a(k);
        A = (a^2-1)/a;
        b = (A-2*a+sqrt((A-2*a)^2-4))/2;
        for j=1:length(freq)
            if freq(j) == 4
                tmp = -a/b*abs(1+b*exp(-1i*pi))^2/abs(1-2*a*exp(-1i*pi)+a^2*exp(-2*1i*pi)).^2;
            else
                tmp = -a/b*abs(1+b*exp(-1i*freq(j)))^2/abs(1-2*a*exp(-1i*freq(j))+a^2*exp(-2*1i*freq(j))).^2;
            end
            P(j,k) = tmp;
            for ii=1:d-1
                P(ii*length(freq)+j,k) = norm(init_w(2*(d-1)*(k-1)+2*ii-1:2*(d-1)*(k-1)+2*ii))^2*tmp;
            end
        end
    end
    for k=num_component-nf1+1:num_component
        a = init_a(k);
        theta = init_f(k);
        A = -(a^2-1)/a;
        b = (A+2*a+sqrt((A+2*a)^2-4))/2;
        for j=1:length(freq)
            if freq(j) == 4
                tmp = a/b*abs(1+b*exp(-1i*pi))^2/abs(1+2*a*exp(-1i*pi)+a^2*exp(-2*1i*pi)).^2;
            else
                tmp = a/b*abs(1+b*exp(-1i*freq(j)))^2/abs(1+2*a*exp(-1i*freq(j))+a^2*exp(-2*1i*freq(j))).^2;
            end
            P(j,k) = tmp;
            for ii=1:d-1
                P(ii*length(freq)+j,k) = norm(init_w(2*(d-1)*(k-1)+2*ii-1:2*(d-1)*(k-1)+2*ii))^2*tmp;
            end
        end
    end
    for k=nf0+1:num_component-nf1
        a = init_a(k);
        theta = init_f(k);
        A = (1-2*a^2*cos(theta)^2+a^4*cos(2*theta))/a/(a^2-1)/cos(theta);
        b = (A-2*a*cos(theta)+sign(cos(theta))*sqrt((A-2*a*cos(theta))^2-4))/2;
        for j=1:length(freq)
            if freq(j) == 4
                tmp = -a*cos(theta)/b*abs(1+b*exp(-1i*pi))^2/abs(1-2*a*cos(theta)*exp(-1i*pi)+a^2*exp(-2*1i*pi)).^2;
            else
                tmp = -a*cos(theta)/b*abs(1+b*exp(-1i*freq(j)))^2/abs(1-2*a*cos(theta)*exp(-1i*freq(j))+a^2*exp(-2*1i*freq(j))).^2;
            end
            P(j,k) = tmp;
            for ii=1:d-1
                P(ii*length(freq)+j,k) = norm(init_w(2*(d-1)*(k-1)+2*ii-1:2*(d-1)*(k-1)+2*ii))^2*tmp;
            end
        end
    end
    [l,bestARdeg] = min(AIC_VARwithnoise);
    A0 = VARwithnoise_A(:,1:d*bestARdeg,bestARdeg);
    E0 = VARwithnoise_E(:,:,bestARdeg);
    p = zeros(d*length(freq),1);
    %{
    tmp = zeros(1,3);
    for ii=1:d
        for j=1:length(freq)
            tmp(1) = abs(Y(ii,:)*exp(-1i*(freq(j)-.01)*(0:T-1)'))^2/T;
            tmp(2) = abs(Y(ii,:)*exp(-1i*freq(j)*(0:T-1)'))^2/T;
            tmp(3) = abs(Y(ii,:)*exp(-1i*(freq(j)+.01)*(0:T-1)'))^2/T;
            p((ii-1)*length(freq)+j) = mean(tmp);
        end
    end
    %}
    for j=1:length(freq)
        Phi = eye(d);
        for k=1:bestARdeg
            Phi = Phi-A0(:,(k-1)*d+1:k*d)*exp(-1i*k*freq(j));
        end
        tmp = inv(Phi)*E0*inv(Phi)';
        for ii=1:d
            p((ii-1)*length(freq)+j) = real(tmp(ii,ii));
        end
    end
    p = zeros(d*length(freq),1);
    d1 = zeros(d*length(freq),1);
    for j=1:length(freq)
        if freq(j) == 0 || freq(j) == 4
            d1(j:length(freq):d*length(freq)) = 1;
        end
        for ii=1:d
            p((ii-1)*length(freq)+j) = abs(Y(ii,:)*exp(-1i*freq(j)*(0:T-1)'))^2/T;
        end
    end
    %init_sigma = (P'*P)\(P'*p);
    %init_sigma(init_sigma<0) = R0;
    init_sigma = expGLMfit(P,p,d1);

    [param,mll] = fminunc(@(param)propV_ll(Y,param),[atanh(2*init_a-1) init_f log(init_sigma'/R0) init_w],options);
    ABIC_prop(num_component) = 2*mll+2*((2*d+1)*num_component+1)
    [mll,tmp] = propV_ll(Y,param);
    prop_a(num_component,1:num_component) = (tanh(param(1:num_component))+1)/2;
    prop_f(num_component,1:num_component) = param(num_component+1:2*num_component);
    prop_sigma(num_component,1:num_component) = exp(param(2*num_component+1:3*num_component))*tmp;
    prop_w(num_component,1:(2*d-2)*num_component) = param(3*num_component+1:(2*d+1)*num_component);
    prop_r(num_component) = tmp;
    
    m = 2*num_component;
    x_pred1 = zeros(m,T);
    x_filt = zeros(m,T);
    x_smooth = zeros(m,T);
    V_pred1 = zeros(m,m,T);
    V_filt = zeros(m,m,T);
    V_smooth = zeros(m,m,T);
    F = zeros(m,m);
    Q = zeros(m,m);
    for k=1:num_component
        F(2*k-1:2*k,2*k-1:2*k) = prop_a(num_component,k)*[cos(prop_f(num_component,k)) -sin(prop_f(num_component,k)); sin(prop_f(num_component,k)) cos(prop_f(num_component,k))];
        Q(2*k-1:2*k,2*k-1:2*k) = prop_sigma(num_component,k)*eye(2);
    end
    H = zeros(d,m);
    H(1,1:2:m) = 1;
    kk = 1;
    for k=1:num_component
        for i=2:d
            H(i,2*k-1:2*k) = prop_w(num_component,kk:kk+1);
            kk = kk+2;
        end
    end
    R = prop_r(num_component)*eye(d);
    x_pred1(:,1) = zeros(m,1);
    for k=1:num_component
        V_pred1(2*k-1:2*k,2*k-1:2*k,1) = Q(2*k-1:2*k,2*k-1:2*k)/(1-F(2*k-1,2*k-1)^2-F(2*k-1,2*k)^2);
    end
    for t=1:T-1
        Kg = V_pred1(:,:,t)*H'*inv(H*V_pred1(:,:,t)*H'+R);
        x_filt(:,t) = x_pred1(:,t) + Kg*(Y(:,t)-H*x_pred1(:,t));
        V_filt(:,:,t) = (eye(m)-Kg*H)*V_pred1(:,:,t);
        x_pred1(:,t+1) = F*x_filt(:,t);
        V_pred1(:,:,t+1) = F*V_filt(:,:,t)*F'+Q;
    end
    Kg = V_pred1(:,:,T)*H'*inv(H*V_pred1(:,:,T)*H'+R);
    x_filt(:,T) = x_pred1(:,T) + Kg*(Y(:,T)-H*x_pred1(:,T));
    V_filt(:,:,T) = (eye(m)-Kg*H)*V_pred1(:,:,T);
    x_smooth(:,T) = x_filt(:,T);
    V_smooth(:,:,T) = V_filt(:,:,T);
    for t=T-1:-1:1
        x_smooth(:,t) = x_filt(:,t) + V_filt(:,:,t)*F'*(V_pred1(:,:,t+1)\(x_smooth(:,t+1)-x_pred1(:,t+1)));
        CC = V_filt(:,:,t)*F'*inv(V_pred1(:,:,t+1));
        V_smooth(:,:,t) = V_filt(:,:,t) + CC*(V_smooth(:,:,t+1)-V_pred1(:,:,t+1))*CC';
    end
    for k=1:num_component
        phi_prop(k,:,num_component) = atan2(x_smooth(2*k,:),x_smooth(2*k-1,:));
    end
    decomp_mu(1:m,:,num_component) = x_smooth;
    decomp_cov(1:m,1:m,:,num_component) = V_smooth;
end

